var authentication;
var mainUrl;

function login() 
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  } 
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }
  
  xmlhttp.onreadystatechange = function() 
  {
    if (this.readyState == 4 && this.status == 200) 
    {
      var loginResponse = JSON.parse(this.responseText);
      authentication = loginResponse.authentication;
      createExternalChatSession();
    }
  };

  setMainUrl();
  var url = mainUrl + "/me/login";

  var username = document.getElementById("username").value;
  var password = document.getElementById("password").value;
  var database = document.getElementById("database").value;
  var credentials = new Object();
  credentials.userName = username;
  credentials.password = password;
  credentials.userSpace = "websocket"; 
  credentials.database = database;

  xmlhttp.open("POST", url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.send(JSON.stringify(credentials));
}

function createExternalChatSession()
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  }
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }

  xmlhttp.onreadystatechange = function () 
  {
    if (this.readyState == 4 && this.status == 200) 
    {
      var response = JSON.parse(this.responseText);
      var chatSession = response.object.oid;
      requestWebSocket(chatSession);
    }
  };

  var externalSessionInfo = new Object();
  externalSessionInfo.clientId = "external1";
  var phoneLine = new Object();
  phoneLine.oid = document.getElementById("line").value;;
  externalSessionInfo.phoneLine = phoneLine;

  var url = mainUrl + "/chats/external_session";
  xmlhttp.open("POST",url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.setRequestHeader("Authorization", "xelion " + authentication);
  xmlhttp.send(JSON.stringify(externalSessionInfo));
}

function requestWebSocket(chatSession)
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  } 
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }
  
  xmlhttp.onreadystatechange = function() 
  {
    if (this.readyState == 4 && this.status == 200) 
    {
      var response = JSON.parse(this.responseText);
      initWebSocket(response.object, chatSession);
    }
  };

  var url = mainUrl + "/me/websocket";
  xmlhttp.open("POST",url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.setRequestHeader("Authorization", "xelion " + authentication);
  xmlhttp.send();
}

function openWebSocket()
{
  var wsurl = document.getElementById("ws").value;
  initWebSocket(wsurl);
}

function handleKeyPress(event)
{
  if(event.keyCode === 13)
  {
    sendChat();
  }
  else
  {
    typing();
  }
}

function sendChat() 
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  }
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }

  xmlhttp.onreadystatechange = function () 
  {
    if (this.readyState == 4 && this.status == 200) 
    {
      var response = JSON.parse(this.responseText);
      document.getElementById("message").value = "";
      writeChat("you: " + response.object.contents);
    }
  };

  var url = mainUrl + "/chats/" + chatSession + "/messages/external";

  var text = document.getElementById("message").value;
  var message = new Object();
  message.text = text;

  xmlhttp.open("POST", url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.setRequestHeader("Authorization", "xelion " + authentication);
  xmlhttp.send(JSON.stringify(message));
}

function typing() 
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  }
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }

  var url = mainUrl + "/chats/" + chatSession + "/is_typing/external";

  xmlhttp.open("POST", url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.setRequestHeader("Authorization", "xelion " + authentication);
  xmlhttp.send();
}

function delivered() 
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  }
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }

  var url = mainUrl + "/chats/" + chatSession + "/delivered/external";

  xmlhttp.open("PUT", url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.setRequestHeader("Authorization", "xelion " + authentication);
  xmlhttp.send();
}

function setMainUrl()
{
  var host = document.getElementById("host").value;
  var tenant = document.getElementById("tenant").value;
  var port = document.getElementById("port").value;
  var ssl = document.getElementById("ssl").checked;

  if(ssl)
  {
    mainUrl = "https://";
  }
  else
  {
    mainUrl = "http://";
  }
  mainUrl = mainUrl + host;
  if(port.length != 0)
  {
    mainUrl = mainUrl + ":" + port;
  }
  mainUrl = mainUrl + "/api/v1/" + tenant;
}
