var output;
var currentVersion = 0;
var calls = new Map();
var channels = new Map();
var chatSession;
var statusWindows;
var chatWindow;

function initWebSocket(url, chatSessionOid)
{
	output = document.getElementById("demo");
	chatSession = chatSessionOid;
	testWebSocket(url);
}

function testWebSocket(url)
{
	websocket = new WebSocket(url);
	websocket.onopen = function(evt) { onOpen(evt) };
	websocket.onclose = function(evt) { onClose(evt) };
	websocket.onmessage = function(evt) { onMessage(evt) };
	websocket.onerror = function(evt) { onError(evt) };
}

function onOpen(evt)
{
	output.innerHTML = "";

	statusWindows = document.createElement("p");
	statusWindows.readOnly = true;
	output.appendChild(statusWindows);

	chatWindow = document.createElement("textArea");
	chatWindow.rows = "20";
	chatWindow.cols = "100";
	chatWindow.readOnly = true;
	output.appendChild(chatWindow);


	console.log("CONNECTED");
	writeToScreen("CONNECTED");

  //
  // request for new external chat events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "newExternalChatEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat typing events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatTypingEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat activated events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatHasBeenActivatedEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat activate user has been changed event
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatActiveUserHasBeenChangedEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat agents available events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatNoAgentsAvailableEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat read events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatHasBeenReadEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat idle events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatIsIdleEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat heartbeat events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatHeartbeatEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));

  //
  // request for chat ended events
  var notificationRequest = new Object();
  notificationRequest.messageType = "notificationRequest";
  notificationRequest.notificationType = "chatHasBeenEndedEvent";
  notificationRequest.toggle = true;
  notificationRequest.oid = chatSession;
  doSend(JSON.stringify(notificationRequest));
}

function onClose(evt)
{
	console.log("DISCONNECTED: " + evt.reason);
	writeToScreen("DISCONNECTED: " + evt.reason);
}

function onMessage(evt)
{
	var notification = JSON.parse(evt.data);
	console.log(notification);
	if(notification.notificationType == "newExternalChatEvent")
	{
		var newChatEvent = notification.notification;
		processIncomingChat(newChatEvent);
	}
	else
	{
		updateStatus(notification.notificationType);
	}
}

function onError(evt)
{
	console.log("ERROR: " + evt.data);
	writeToScreen('<span style="color: red;">ERROR:</span> ' + evt.data);
}

function doSend(message)
{
	console.log("SENT: " + message);
	// writeToScreen("SENT: " + message);
	websocket.send(message);
}

function writeToScreen(message)
{
	// var pre = document.createElement("p");
	// pre.style.wordWrap = "break-word";
	// pre.innerHTML = message;
	// output.appendChild(pre);
}

function writeChat(message)
{
	// var pre = document.createElement("p");
	// pre.style.wordWrap = "break-word";
	chatWindow.innerHTML = chatWindow.innerHTML + "\n" + message;
	chatWindow.scrollTop = chatWindow.scrollHeight - chatWindow.clientHeight;
	// output.appendChild(pre);
}

function processIncomingChat(evt)
{
	writeChat("incoming: " + evt.contents);
	delivered();
}

function updateStatus(evt)
{
	statusWindows.innerHTML = evt;
}
